# AmazonAddSecurityGroupRuleParameters Object

## Description

Parameters for the Amazon Add Security Group Rule action.

## Properties

### credentialIds

Registered credentials to use with the action. One and only one credential must be specified.

Type: Array of `string`

Required: Yes

### description

A description to add to the new rule.

Type: `string`

Required: No

### direction

Direction for the rule.

Type: `string`

Valid Values:

* `inbound`
* `outbound`

Required: Yes

### fromPort

Starting number of the port range (inclusive) to use for the rule.

Type: `integer`

Valid Values: 1 to 65536

Required: Yes

### protocol

Protocol for the rule.

Type: `string`

Valid Values:

* `tcp`
* `udp`
* `icmp`

Required: Yes

### regionNames

Regions to use with the action. One and only one region must be specified.

Type: Array of `string`

Required: Yes

### registerMultipleDnsEntries

Indicates whether to register all resolved DNS entries or just a single one (randomly). Required if `sourceType` is `domain-name`.

Type: `string`

Valid Values:

* `all`
* `single-random`

Required: Conditional

### revokeOldRules

Indicates whether old rules will be removed from the security group before the new rule is added.

Type: `string`

Valid Values:

* `none`
* `all`
* `all-same-direction`

Required: No

Default: `none`

### revokeTimeInSeconds

Time, in seconds, after which the security group rule will be removed.

Type: `integer`

Valid Values: 1 to 86400

Required: No

### securityGroup

Security group to which the rule will be added.

Type: `string`

Required: Yes

### source

Source to use for the new rule.

Type: `string`

Required: Yes

### sourceType

Type of source for the rule.

Type: `string`

Valid Values:

* `cidr`
* `security-group`
* `domain-name`

Required: Yes

### toPort

Ending number of the port range (inclusive) to use for the rule. Must be greater than or equal to `fromPort`.

Type: `integer`

Valid Values: 1 to 65536

Required: Yes

## Sample JSON

```javascript
{
    "credentialIds": [
        "cred-00000001"
    ],
    "regionNames": [
        "us-east-1"
    ],
    "direction": "inbound",
    "protocol": "tcp",
    "fromPort": 22,
    "toPort": 22,
    "securityGroup": "sg-12345678",
    "sourceType": "cidr",
    "source": "10.11.12.13/32",
    "registerMultipleDnsEntries": "single-random",
    "revokeOldRules": "all-same-direction"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.skeddly.com/data-types/actionparameters-object/amazonaddsecuritygroupruleparameters-object.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
